package com.ruoyi.bst.channel.service;

import com.ruoyi.bst.channel.domain.Channel;
import com.ruoyi.bst.channel.domain.ChannelQuery;
import com.ruoyi.bst.channel.domain.ChannelVO;
import com.ruoyi.bst.channel.domain.vo.ChannelNameVO;

import java.util.List;
import java.util.Map;
import java.util.function.Function;

/**
 * 充值渠道Service接口
 *
 * @author ruoyi
 * @date 2024-04-15
 */
public interface ChannelService
{
    /**
     * 查询充值渠道
     *
     * @param channelId 充值渠道主键
     * @return 充值渠道
     */
    public ChannelVO selectChannelByChannelId(Long channelId);

    /**
     * 查询充值渠道列表
     *
     * @param smChannel 充值渠道
     * @return 充值渠道集合
     */
    public List<ChannelVO> selectChannelList(ChannelQuery smChannel);

    /**
     * 新增充值渠道
     *
     * @param channel 充值渠道
     * @return 结果
     */
    public int insertChannel(Channel channel);

    /**
     * 修改充值渠道
     *
     * @param channel 充值渠道
     * @return 结果
     */
    public int updateChannel(Channel channel);

    /**
     * 查询启用的充值渠道列表
     *
     * @return
     */
    List<ChannelVO> selectEnabledRechargeList(ChannelQuery query);

    /**
     * 查询充值渠道映射表
     *
     * @param query     查询条件
     * @param keyMapper 映射函数
     */
    <K> Map<K, ChannelVO> selectMap(ChannelQuery query, Function<? super Channel, ? extends K> keyMapper);

    /**
     * 批量逻辑删除
     */
    int logicDel(List<Long> ids);

    /**
     * 根据id查询
     */
    List<ChannelVO> selectByIds(List<Long> ids);

    /**
     * 查询全部充值渠道名称列表
     */
    List<ChannelNameVO> selectAllChannelNameList();

}
